<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Script/surfaceGenerator.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Script/surfaceGenerator.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * Calculator module - See {@tutorial calculator-tutorial}
 * @module l_3d_map_visualization_client
 * @description 
 
 * 
 * &lt;h3> Concept  &lt;/h3>
 * 
 * &lt;h4>1. Generate 3d surface prototype in d3.select&lt;/h4>
 * &lt;p>see module surface3d.js&lt;/p>
 * &lt;p>The 3D surface plot is attached to the d3 select method of the data driven documents framework. Therefor a prototype of the surface3D
 * class is created which has the following members : &lt;/p>
 * 
 * &lt;table>
 *   &lt;caption>d3.selection.prototype.surface3D=function(width,height)&lt;/caption>
 *   &lt;thead>&lt;tr>&lt;th>Member&lt;/th>&lt;th>Method&lt;/th>&lt;th>description&lt;/th>&lt;/tr>&lt;/thead>
 *   &lt;tr>&lt;td>__surface__&lt;/td>&lt;td>new Surface(this)&lt;/td>&lt;td>if there is no surface object yet, create a surface object and store it to the __surface__ member&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>turntable&lt;/td>&lt;td>surface.setTurtable&lt;/td>&lt;td>copy the turntable method from the __surface__ member to the node&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>surfaceColor&lt;/td>&lt;td>map&lt;/td>&lt;td>copy surface color method to this node member&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>surfaceHeight&lt;/td>&lt;td>map&lt;/td>&lt;td>copy surface heigth method to this node member&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>surfaceXAxis&lt;/td>&lt;td>map&lt;/td>&lt;td>copy surface x axis to this node member&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>surfaceYAxis&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>copy surface y axis to this node member&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>zoom&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>zoom factor method of surface object&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>transition&lt;/td>&lt;td>surface.transition.bind(surface)&lt;/td>&lt;td>tansition method of a d3 selection is used to fade in the new surface object&lt;/td>&lt;/tr>
 * &lt;/table>
 * 
 * &lt;p>For the explanation of the prototype function {@tutorial graphicalEditor} &lt;/p>
 * 
 * &lt;h4>2. Generate 3d surface data and graphic&lt;/h4>
 * 
 * &lt;h4> 2.1 create default data &lt;/h4>
 * &lt;p> var surfaces=[ &lt;/p>
 * &lt;p>  { &lt;/p>
 * &lt;p>    name: 'Dataset 1',&lt;/p>
 * &lt;p>    data: dataFromFormular(function(x,y){&lt;/p>
 * &lt;p>        return Math.sin(Math.sqrt(x*x+y*y)/5*Math.PI)*50;&lt;/p>
 * &lt;p>      })&lt;/p>
 * &lt;p>  },&lt;/p>
 * 
 * &lt;h4>2.2 Attach data to a d3 selection and create surface3D object&lt;/h4>
 *  &lt;p>var md=group.data([surfaces[0].data])&lt;/p>
 *  &lt;p> .surface3D(width,height)&lt;/p>
 *  &lt;p>   .surfaceHeight(function(d){ &lt;/p>
 *  &lt;p>     return d;&lt;/p>
 *  &lt;p>   }).surfaceColor(function(d){&lt;/p>
 *  &lt;p>     var c=d3.hsl((d+100), 0.6, 0.5).rgb();&lt;/p>
 *  &lt;p>     return "rgb("+parseInt(c.r)+","+parseInt(c.g)+","+parseInt(c.b)+")";&lt;/p>
 *  &lt;p>   }).surfaceXAxis(function(d){ return d})&lt;/p>
 *  &lt;p>   .surfaceYAxis(function(d){return d});&lt;/p>
 * 
 * &lt;h4>2.3 Update data : function dataFromDatabase&lt;/h4>
 * 
 * Once the 3d map is initialized the getTable event is sent to the server which replies with a sendTable event. 
 * On the sendTable event the new postgres data is received and stored to an data vector in an appropriate form. 
 * 
 * &lt;h4>2.4 Create new surface&lt;/h4>
 * 
 * The new postgres data is loaded into the svg graph data member and the surface3D constructor is called. This
 * creates a new surface with the updated data. 
 * 
 */

/** @function dataFromDataBase
 * @description once the 3d visualization is created and initialized, new data is read from postgres. 
 * The array of new data is loaded into the 3d map data object and the surface3D contructor is called. 
 * This triggers a newly created surface. 
 * 
 */

var width=1400, height=800;
var d3 = window.d3;


function dataFromDatabase(data){
  var output={};
  output.spx = [];
  output.spy = [];
  output.data = [];
 
  var outerdata_vec = [];
  for(var xIt=0;xIt&lt;data.length;xIt++)
  {
    var outer_vec = data[xIt];
    if(xIt==0)
    {      
      outer_vec.shift();
      for(var it=0;it&lt;outer_vec.length;it++)
      {
        output.spy.push(parseFloat(outer_vec[it]));  
      }      
    } 
    else {
      output.spx.push(parseFloat(outer_vec[0]));
      var innerdata_vec = []
      for(var yIt=1;yIt&lt;outer_vec.length;yIt++)   
      {
        innerdata_vec.push(parseFloat(outer_vec[yIt]));
      }
      outerdata_vec.push(innerdata_vec);
    }            
  }
  output.data = outerdata_vec;
  return output;
}



  function dataFromFormular(func){
    var output={};
    output.spx = [];
    output.spy = [];
    output.data = [];
    var b_first = false;
    for(var x=-20;x&lt;20;x++){
      var f0=[];            
      output.data.push(f0);
      output.spx.push(parseFloat(2*x));
      for(var y=-20;y&lt;20;y++){
          f0.push(func(x,y));
          if(!b_first)
          {            
            output.spy.push(parseFloat(Math.pow(y+20,2)));
          }          
      }
      b_first = true
    }
    return output;
  }

  var surfaces=[
    {
      name: 'Dataset 1',
      data: dataFromFormular(function(x,y){
          return Math.sin(Math.sqrt(x*x+y*y)/5*Math.PI)*50;
        })
    },
    {
      name: 'Dataset 2',
      data: dataFromFormular(function(x,y){
          return Math.cos(x/15*Math.PI)*Math.cos(y/15*Math.PI)*60+Math.cos(x/8*Math.PI)*Math.cos(y/10*Math.PI)*40;
        })
    },
    {
      name: 'Dataset 3',
      data: dataFromFormular(function(x,y){
          return -(Math.cos(Math.sqrt(x*x+y*y)/6*Math.PI)+1)*300/(Math.pow(x*x+y*y+1,0.3)+1)+50;
        })
    }
  ];
  
  

  
  d3.select('body')
           .append('ul');
  var svg=d3.select('body')
          .append('svg')
            .attr('id','3dsurface')
            .attr('height',height)
            .attr('width',width);

  var group = svg.append("g");

  var md=group.data([surfaces[0].data])
    .surface3D(width,height)
      .surfaceHeight(function(d){ 
        return d;
      }).surfaceColor(function(d){
        var c=d3.hsl((d+100), 0.6, 0.5).rgb();
        return "rgb("+parseInt(c.r)+","+parseInt(c.g)+","+parseInt(c.b)+")";
      }).surfaceXAxis(function(d){ return d})
      .surfaceYAxis(function(d){return d});

  
  var dragObj={};

  function getAngleInRad(rel){
    const low = -Math.PI/2
    const high = Math.PI/2

    var val = (high-low)*rel + low     
    return val;
  }
            
  function dragHandlerY(event) {
    var bindingGrp = this.parentNode.getBoundingClientRect();        
    var maxhigh = bindingGrp.height;
    var pitchhigh = this.getBoundingClientRect().height;
    var yPar =  event.y;
    if(yPar >= (maxhigh-pitchhigh)) 
    { 
      yPar = parseFloat(maxhigh-pitchhigh);
    }
    if(yPar &lt;= 0) 
    { 
      yPar = 0;
    }
    
    
    d3.select(this)            
        .attr("y", yPar);

    var rel = parseFloat((yPar)/(maxhigh-pitchhigh));   
     
    
    var parent = d3.select(this.parentNode);
    height = parent.attr("height");

    var pitch = getAngleInRad(rel)
    dragObj.pitch = pitch;
    
    if(!Object.getOwnPropertyDescriptor(dragObj, "yaw"))
    {
      dragObj.yaw = 0
    }    
    md.turntable(dragObj.yaw,dragObj.pitch);    
    console.log(rel,yPar);
  }

  function dragHandlerX(event) {
    var bindingGrp = this.parentNode.getBoundingClientRect();        
    var maxwidth = bindingGrp.width;
    var pitchwidth = this.getBoundingClientRect().width;
    var xPar =  event.x;
    if(xPar >= (maxwidth-pitchwidth)) 
    { 
      xPar = parseFloat(maxwidth-pitchwidth);
    }
    if(xPar &lt;= 0) 
    { 
      xPar = 0;
    }
    d3.select(this)            
        .attr("x", xPar);

    var rel = parseFloat((xPar)/(maxwidth-pitchwidth));    
    //parent = d3.select(this.parentNode);
    width = d3.select(this.parentNode).attr("width");

    var yaw = getAngleInRad(rel)
    dragObj.yaw = yaw;    
    if(!Object.getOwnPropertyDescriptor(dragObj, "pitch"))
    {
      dragObj.pitch = 0
    }    
    md.turntable(dragObj.yaw,dragObj.pitch);    
    console.log(rel,xPar);
  }

      //Implement scroll groups
      var element3d = document.getElementById("3dsurface");
      var scrgrpselY = d3.select(element3d).append('g').attr('id','scrollgroupY');
      var scrgrpselX = d3.select(element3d).append('g').attr('id','scrollgroupX');
      var frm = element3d.getBoundingClientRect()
      var high = frm.height;      
      width = frm.width;      
      scrgrpselY.append('rect')
      .attr('width', 10)
      .attr('rx', 10/2)
      .attr('ry', 10/2)
      .attr('fill', 'transparent')
      .attr('id', 'scrollFrameY')
      .attr('height', parseFloat(high));
      
      scrgrpselY.append('rect')
      .attr('width', 10)
      .attr('rx', 10/2)
      .attr('ry', 10/2)
      .attr('id', 'scrollPitchY')
      .attr('height', parseFloat(high/10))
      .call(d3.drag()        
        .on('drag', dragHandlerY)        
        );

      scrgrpselX.append('rect')
      .attr('width', parseFloat(width))
      .attr('rx', 10/2)
      .attr('ry', 10/2)
      .attr('fill', 'transparent')
      .attr('id', 'scrollFrameX')
      .attr('height', 10);

      scrgrpselX.append('rect')
      .attr('width', parseFloat(width/10))
      .attr('rx', 10/2)
      .attr('ry', 10/2)
      .attr('id', 'scrollPitchX')
      .attr('height', 10)
      .call(d3.drag()        
        .on('drag', dragHandlerX)        
        );
  
  export {dataFromDatabase};
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
